Loading...
Searching...
No Matches
casacore::LELUnaryConst< T > Class Template Reference
lattices package (libcasa_lattices) » LEL_module » LEL_module_internal_classes

More...

`#include <LELUnary.h>`

## Public Member Functions

| LELUnaryConst ()
| Default constructor creates a scalar with a false mask.
| LELUnaryConst (const T val)
| Constructor takes a scalar.
| ~LELUnaryConst ()
| Destructor does nothing.
virtual void | eval (LELArray< T > &result, const Slicer &section) const
| Evaluate the expression.
virtual LELScalar< T > | getScalar () const
| Evaluate the scalar expression (get the constant).
virtual Bool | prepareScalarExpr ()
| Do further preparations (e.g.
virtual String | className () const
| Get class name.
Public Member Functions inherited from casacore::LELInterface< T >
virtual | ~LELInterface ()
| Virtual destructor.
virtual void | evalRef (LELArrayRef< T > &result, const Slicer &section) const
LELArray< T > | getArray () const
| Get the result of an array subexpression.
Bool | isScalar () const
| Is the result of evaluating this expression a scalar ?
const IPosition & | shape () const
| Get the shape of the expression result.
const LELAttribute & | getAttribute () const
| Get expression attribute.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle locking/syncing of the parts of a lattice expression.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()

## Private Attributes

LELScalar< T > | val_p

## Additional Inherited Members

Static Public Member Functions inherited from casacore::LELInterface< T >
static Bool | replaceScalarExpr (std::shared_ptr< LELInterface< T > > &expr)
| If the given expression is a valid scalar, replace it by its result.
Protected Member Functions inherited from casacore::LELInterface< T >
void | setAttr (const LELAttribute &attrib)
| Set the expression attributes of this object.

## Detailed Description

template<class T>
class casacore::LELUnaryConst< T >

This LEL class handles scalar (unary) constants

### Intended use:

Internal

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Lattice
- LatticeExpr
- LatticeExprNode
- LELInterface
- LELUnaryEnums

### Etymology

This derived LEL letter class handles scalar (unary) constants

### Synopsis

This LEL letter class is derived from LELInterface. It is used to construct LEL objects that represent scalars constants. They can be of type Float,Double,Complex,DComplex and Bool.

A description of the implementation details of the LEL classes can be found in Note 216

### Example

Examples are not very useful as the user would never use these classes directly. Look in LatticeExprNode.cc to see how it invokes these classes. Examples of how the user would indirectly use this class (through the envelope) are:

IPosition shape(2,5,10);
ArrayLattice<Float> x(shape); x.set(1.0);
ArrayLattice<Float> y(shape);
ArrayLattice<Float> z(shape);
y.copyData(x+2.0); // y = x + 2.0
z.copyData(True); // z = True
casacore::ArrayLattice
Definition ArrayLattice.h:144
casacore::IPosition
Definition IPosition.h:117
casacore::LELInterface::shape
const IPosition & shape() const
Get the shape of the expression result.
Definition LELInterface.h:180
casacore::True
const Bool True
Definition aipstype.h:41

### Motivation

Constants are a basic mathematical expression.

Definition at line 94 of file LELUnary.h.

## Constructor & Destructor Documentation

## LELUnaryConst() [1/2]

template<class T>

casacore::LELUnaryConst< T >::LELUnaryConst | ( |  | ) |

Default constructor creates a scalar with a false mask.

## LELUnaryConst() [2/2]

template<class T>

casacore::LELUnaryConst< T >::LELUnaryConst | ( | const T | val | ) |

Constructor takes a scalar.

## ~LELUnaryConst()

template<class T>

casacore::LELUnaryConst< T >::~LELUnaryConst | ( |  | ) |

Destructor does nothing.

## Member Function Documentation

## className()

template<class T>

virtual String casacore::LELUnaryConst< T >::className | ( |  | ) | const

virtual

Get class name.

Implements casacore::LELInterface< T >.

## eval()

template<class T>

virtual void casacore::LELUnaryConst< T >::eval | ( | LELArray< T > & | result,
|  | const Slicer & | section ) const

virtual

Evaluate the expression.

This throws an exception, since only a scalar can be returned.

Implements casacore::LELInterface< T >.

## getScalar()

template<class T>

virtual LELScalar< T > casacore::LELUnaryConst< T >::getScalar | ( |  | ) | const

virtual

Evaluate the scalar expression (get the constant).

Implements casacore::LELInterface< T >.

## prepareScalarExpr()

template<class T>

virtual Bool casacore::LELUnaryConst< T >::prepareScalarExpr | ( |  | ) |

virtual

Do further preparations (e.g.

optimization) on the expression.

Implements casacore::LELInterface< T >.

## Member Data Documentation

## val_p

template<class T>

LELScalar<T> casacore::LELUnaryConst< T >::val_p

private

Definition at line 125 of file LELUnary.h.

The documentation for this class was generated from the following file:

- lattices/LEL/LELUnary.h